=== debian/changelog ===
cyclonedds (0.10.2-2) unstable; urgency=medium

  * Upload to unstable
  * Drop obsolete pubsub.1 manual page

 -- Timo Röhling <roehling@debian.org>  Thu, 22 Sep 2022 14:51:49 +0200

cyclonedds (0.10.2-1) experimental; urgency=medium

  * New upstream version 0.10.2
  * Bump Standards-Version to 4.6.1
  * Update d/watch
  * Bump SONAME for libddsc to "0debian"

 -- Timo Röhling <roehling@debian.org>  Tue, 20 Sep 2022 22:04:12 +0200
